## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## Implementaion of miscellaneous game functions

import CvUtil
from CvPythonExtensions import *
import CvEventInterface
import GodsOfOld
import Popup as PyPopup
import PyHelpers

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
PyCity = PyHelpers.PyCity
PyGame = PyHelpers.PyGame

class CvGameUtils:
	"Miscellaneous game functions"
	def __init__(self): 
		pass
	
	def isVictoryTest(self):
		if ( gc.getGame().getElapsedGameTurns() > 10 ):
			return True
		else:
			return False

	def isVictory(self, argsList):
		eVictory = argsList[0]
		
		return True

	def isPlayerResearch(self, argsList):
		ePlayer = argsList[0]
		return True

	def getExtraCost(self, argsList):
		ePlayer = argsList[0]
		return 0

	def createBarbarianCities(self):
		return False
		
	def createBarbarianUnits(self):
		return False
		
	def skipResearchPopup(self,argsList):
		ePlayer = argsList[0]
		return False
		
	def showTechChooserButton(self,argsList):
		ePlayer = argsList[0]
		return True

	def getFirstRecommendedTech(self,argsList):
		ePlayer = argsList[0]
		return TechTypes.NO_TECH

	def getSecondRecommendedTech(self,argsList):
		ePlayer = argsList[0]
		eFirstTech = argsList[1]
		return TechTypes.NO_TECH
	
	def canRazeCity(self,argsList):
		iRazingPlayer, pCity = argsList
		return True
	
	def canDeclareWar(self,argsList):
		iAttackingTeam, iDefendingTeam = argsList

## Needs to be Cleaned Up Later / Temp Tesla Fix ##

		pTeam = gc.getPlayer(iAttackingTeam)

		b_Himeji = gc.getInfoTypeForString("BUILDING_TESLA")
		obsoleteTech = gc.getBuildingInfo(b_Himeji).getObsoleteTech()

		if ( gc.getTeam(pTeam.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
			for iCity in range(pTeam.getNumCities()):
				ppCity = pTeam.getCity(iCity)
				if ppCity.getNumActiveBuilding(b_Himeji) == true:
					return False

## Needs to be Cleaned Up Later / Temp Tesla Fix ##

		return True
	
	def skipProductionPopup(self,argsList):
		pCity = argsList[0]
		return False
		
	def showExamineCityButton(self,argsList):
		pCity = argsList[0]
		return True

	def getRecommendedUnit(self,argsList):
		pCity = argsList[0]
		return UnitTypes.NO_UNIT

	def getRecommendedBuilding(self,argsList):
		pCity = argsList[0]
		return BuildingTypes.NO_BUILDING

	def updateColoredPlots(self):
		return False

	def isActionRecommended(self,argsList):
		pUnit = argsList[0]
		iAction = argsList[1]
		return False

	def unitCannotMoveInto(self,argsList):
		ePlayer = argsList[0]		
		iUnitId = argsList[1]
		iPlotX = argsList[2]
		iPlotY = argsList[3]
		return False

	def cannotHandleAction(self,argsList):
		pPlot = argsList[0]
		iAction = argsList[1]
		bTestVisible = argsList[2]
		return False

	def canBuild(self,argsList):
		iX, iY, iBuild, iPlayer = argsList

## Marsh and Roman Road Improvements ## Disabled for the time being
#
#		pPlot = CyMap().plot(iX, iY)
#		iTeam = gc.getPlayer(iPlayer).getTeam()
#		pPlayer = gc.getPlayer(iPlayer)
#
#		iRomanRoadBuild = gc.getInfoTypeForString("BUILD_ROMAN_ROAD")
#		bVia = gc.getInfoTypeForString("BUILDING_VIA_APPIA")
#		iRailroad = gc.getInfoTypeForString( 'TECH_RAILROAD' )
#		tt_marsh = gc.getInfoTypeForString( 'TERRAIN_MARSH' )
#		iCivil = gc.getInfoTypeForString( 'TECH_CIVIL_SERVICE' )
#		iRoadBuild = gc.getInfoTypeForString("BUILD_ROAD")
#		iWheel = gc.getInfoTypeForString( 'TECH_THE_WHEEL' )
#		iEconomyCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_ECONOMY')
#		iEnvironmental = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_ENVIRONMENTALISM')
#		iEconomyCivic = pPlayer.getCivics(iEconomyCivicOption)
#
#		if ( pPlot.getTerrainType()== tt_marsh ):
#			if (iBuild != iRoadBuild):
#				if ( not gc.getTeam(iTeam).isHasTech(iCivil) ):
#					return 0
#
#		if (iBuild == iRomanRoadBuild):
#			for iCity in range(pPlayer.getNumCities()):
#				ppCity = pPlayer.getCity(iCity)
#				if ppCity.getNumActiveBuilding(bVia) == true:
#					return -1
#				else:
#					return 0
#
#		if (iBuild == iRomanRoadBuild):
#			if ( gc.getTeam(iTeam).isHasTech(iRailroad) ):
#				return 0
#
#		if (iEconomyCivic == iEnvironmental):
#			if ( pPlot.getTerrainType()== tt_marsh ):
#				return 0
#
## Marsh and Roman Road Improvements ## Disabled for the time being

		return -1	# Returning -1 means ignore; 0 means Build cannot be performed; 1

	def cannotFoundCity(self,argsList):
		iPlayer, iPlotX, iPlotY = argsList
		return False

	def cannotSelectionListMove(self,argsList):
		pPlot = argsList[0]
		bAlt = argsList[1]
		bShift = argsList[2]
		bCtrl = argsList[3]
		return False

	def cannotSelectionListGameNetMessage(self,argsList):
		eMessage = argsList[0]
		iData2 = argsList[1]
		iData3 = argsList[2]
		iData4 = argsList[3]
		iFlags = argsList[4]
		bAlt = argsList[5]
		bShift = argsList[6]
		return False

	def cannotDoControl(self,argsList):
		eControl = argsList[0]
		return False

	def canResearch(self,argsList):
		ePlayer = argsList[0]
		eTech = argsList[1]
		bTrade = argsList[2]
		return False

	def cannotResearch(self,argsList):
		ePlayer = argsList[0]
		eTech = argsList[1]
		bTrade = argsList[2]
		return False

	def canDoCivic(self,argsList):
		ePlayer = argsList[0]
		eCivic = argsList[1]
		return False

	def cannotDoCivic(self,argsList):
		ePlayer = argsList[0]
		eCivic = argsList[1]
		return False
		
	def canTrain(self,argsList):
		pCity = argsList[0]
		eUnit = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		bIgnoreCost = argsList[4]
		bIgnoreUpgrades = argsList[5]
		return False

	def cannotTrain(self,argsList):
		pCity = argsList[0]
		eUnit = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		bIgnoreCost = argsList[4]
		bIgnoreUpgrades = argsList[5]

## Civic Specific Unit ##

		iCaravan = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CARAVAN')
		iInquisitor = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_INQUISITOR')
		iLawyer = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_LAWYER')
		iPrivate1 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PRIVATEER')
		iPrivate2 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CHAM')

        	if eUnit == iCaravan:
			if not gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_BARTER')):
                		return True

        	if eUnit == iInquisitor:
			if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_FREE_RELIGION')):
                		return True

        	if eUnit == iLawyer:
			if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_JUDICIAL')):
                		return True
			if not gc.getPlayer(pCity.getOwner()).isHuman( ):
				return True

        	if eUnit == iPrivate1:
			if not gc.getPlayer(pCity.getOwner()).isHuman( ):
				return True

        	if eUnit == iPrivate2:
			if not gc.getPlayer(pCity.getOwner()).isHuman( ):
				return True

## Civic Specific Unit ##

## Crusader ##

		religion = "NONE"
		iCrusader = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CRUSADER')

        	if eUnit == iCrusader:
            	        if gc.getPlayer(pCity.getOwner()).getStateReligion() == gc.getInfoTypeForString(religion):
                		return True

## Crusader ##

## Andromeda ##

		bBio = gc.getInfoTypeForString("BUILDING_BIOLOGICAL_WARFARE_LAB")
		iAndromeda = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ANDROMEDA')

        	if eUnit == iAndromeda:
            	        if pCity.getNumActiveBuilding(bBio) == false:
				return True

## Andromeda ##

## Atheism ##

		pPlayer = gc.getPlayer(pCity.getOwner())

		iReligionCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_RELIGION')
		iAtheism = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_ATH')
		iReligionCivic = pPlayer.getCivics(iReligionCivicOption)

		iMissionary1 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_JEWISH_MISSIONARY')
		iMissionary2 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CHRISTIAN_MISSIONARY')
		iMissionary3 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_HINDU_MISSIONARY')
		iMissionary4 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_BUDDHIST_MISSIONARY')
		iMissionary5 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CONFUCIAN_MISSIONARY')
		iMissionary6 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TAOIST_MISSIONARY')
		iMissionary7 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PAGAN_MISSIONARY')
		iMissionary8 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ISLAMIC_MISSIONARY')
		iMissionary9 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ZORO_MISSIONARY')
		iMissionary10 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_SHINTO_MISSIONARY')
		iMissionary11 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ASEN_MISSIONARY')
		iMissionary12 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_RA_MISSIONARY')
		iMissionary13 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TOLTEC_MISSIONARY')
		iMissionary14 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_VOODOO_MISSIONARY')
		iMissionary15 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TENGRI_MISSIONARY')
		iMissionary16 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_LEVANT_MISSIONARY')

		aiDiplomatList = [iMissionary1, iMissionary2, iMissionary3, iMissionary4, iMissionary5, iMissionary6, iMissionary7, iMissionary8, iMissionary9, iMissionary10, iMissionary11, iMissionary12, iMissionary13, iMissionary14, iMissionary15, iMissionary16]

		if (iReligionCivic == iAtheism):
			if (eUnit in aiDiplomatList):
				return True

#        	if eUnit == iMissionary1:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary2:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary3:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary4:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary5:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary6:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary7:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary8:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary9:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary10:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary11:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary12:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary13:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary14:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary15:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
#        	if eUnit == iMissionary16:
#            	        if gc.getPlayer(pCity.getOwner()).isCivic(gc.getInfoTypeForString('CIVIC_ATH')):
#                		return True
#
## Atheism ##

		return False

	def canConstruct(self,argsList):
		pCity = argsList[0]
		eBuilding = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		bIgnoreCost = argsList[4]
		return False

	def cannotConstruct(self,argsList):
		pCity = argsList[0]
		eBuilding = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		bIgnoreCost = argsList[4]

## Petra Fix ##

		lgleicheBC = []
		buildingClassType = gc.getBuildingInfo(eBuilding).getBuildingClassType()
		for i in range(gc.getNumBuildingInfos()):
			if ( buildingClassType == gc.getBuildingInfo(i).getBuildingClassType() ):
				lgleicheBC.append(i)

		if ( len(lgleicheBC) >= 2 ):
			### is eBuilding the default building? ###
			if ( eBuilding == lgleicheBC[0] ):
				### do you have a "foreign" UB in the city? ###
				for i in range(len(lgleicheBC)-1):
					if ( pCity.getNumActiveBuilding(lgleicheBC[i +1])==true ):
						return True

## Petra Fix ##
		
### Force Shield Edit###

		# player can't build shielding depending on other shieldings in the city
		if eBuilding == gc.getInfoTypeForString("BUILDING_ARCOLOGY"):
			if pCity.getNumRealBuilding(gc.getInfoTypeForString("BUILDING_ARCOLOGY_SHIELDING")) or pCity.getNumRealBuilding(gc.getInfoTypeForString("BUILDING_ADVANCED_SHIELDING")) or pCity.getNumRealBuilding(gc.getInfoTypeForString("BUILDING_ADVANCED_SHIELDING3")):
				return True
		
		# player can't build shielding depending on other shieldings in the city
		if eBuilding == gc.getInfoTypeForString("BUILDING_ARCOLOGY_SHIELDING"):
			if pCity.getNumRealBuilding(gc.getInfoTypeForString("BUILDING_ADVANCED_SHIELDING")) or pCity.getNumRealBuilding(gc.getInfoTypeForString("BUILDING_ADVANCED_SHIELDING3")):
				return True

		# player can't build shielding depending on other shieldings in the city
		if eBuilding == gc.getInfoTypeForString("BUILDING_ADVANCED_SHIELDING"):
			if pCity.getNumRealBuilding(gc.getInfoTypeForString("BUILDING_ADVANCED_SHIELDING3")):
				return True

### Force Shield Edit###

### MachuPicchu Mod Begins ###

		if ( eBuilding == gc.getInfoTypeForString("BUILDING_MACHU_PICCHU") ):

			### find peaks within the city radius controlled by your team ###
			pPlayer = gc.getPlayer(pCity.plot().getOwner())
			iPID = pPlayer.getID()
			iTID = pPlayer.getTeam()
			iX = pCity.getX()
			iY = pCity.getY()

			for iXLoop in range(iX - 2, iX + 3, 1):
				for iYLoop in range(iY - 2, iY + 3, 1):
					pPlot = CyMap().plot(iXLoop, iYLoop)
					if ( pPlot.isPlayerCityRadius(iPID)==true ):
						if ( pPlot.getTeam()==iTID ):
							if ( pPlot.isPeak()==true  ):
								return False
			return True

### MachuPicchu Mod Ends ###

### Djenne Start ###

		if ( eBuilding == gc.getInfoTypeForString("BUILDING_DJENNE") ):

			pPlayer = gc.getPlayer(pCity.plot().getOwner())
			iPID = pPlayer.getID()
			iTID = pPlayer.getTeam()
			iX = pCity.getX()
			iY = pCity.getY()
			tt_desert = gc.getInfoTypeForString( 'TERRAIN_DESERT' )

			for iXLoop in range(iX - 2, iX + 3, 1):
				for iYLoop in range(iY - 2, iY + 3, 1):
					pPlot = CyMap().plot(iXLoop, iYLoop)
					if ( pPlot.isPlayerCityRadius(iPID)==true ):
						if ( pPlot.getTeam()==iTID ):
							if ( pPlot.getTerrainType()==tt_desert ):
								return False
			return True

### Djenne End ###

### Ice Hotel Start ###

		if ( eBuilding == gc.getInfoTypeForString("BUILDING_ICE_HOTEL") ):

			pPlayer = gc.getPlayer(pCity.plot().getOwner())
			iPID = pPlayer.getID()
			iTID = pPlayer.getTeam()
			iX = pCity.getX()
			iY = pCity.getY()
			tt_snow = gc.getInfoTypeForString( 'TERRAIN_SNOW' )

			for iXLoop in range(iX - 2, iX + 3, 1):
				for iYLoop in range(iY - 2, iY + 3, 1):
					pPlot = CyMap().plot(iXLoop, iYLoop)
					if ( pPlot.isPlayerCityRadius(iPID)==true ):
						if ( pPlot.getTeam()==iTID ):
							if ( pPlot.getTerrainType()==tt_snow ):
								return False
			return True

### Ice Hotel End ###

## Golden Dawn Start ##

		if ( eBuilding == gc.getInfoTypeForString("BUILDING_COPERNICUS") ):

			bFoundValid = false
			iTech = CvUtil.findInfoTypeNum(gc.getTechInfo, gc.getNumTechInfos(), 'TECH_DIVINE_RIGHT')
			for iPlayer in range(gc.getMAX_CIV_PLAYERS()):			
				loopPlayer = gc.getPlayer(iPlayer)
				if loopPlayer.isAlive():
					if gc.getTeam(loopPlayer.getTeam()).isHasTech(iTech):
						bFoundValid = true
						break

			if not bFoundValid:
				return True


			bFoundValid = false
			iTech = CvUtil.findInfoTypeNum(gc.getTechInfo, gc.getNumTechInfos(), 'TECH_CODE_OF_LAWS')
			for iPlayer in range(gc.getMAX_CIV_PLAYERS()):			
				loopPlayer = gc.getPlayer(iPlayer)
				if loopPlayer.isAlive():
					if gc.getTeam(loopPlayer.getTeam()).isHasTech(iTech):
						bFoundValid = true
						break

			if not bFoundValid:
				return True

			bFoundValid = false
			iTech = CvUtil.findInfoTypeNum(gc.getTechInfo, gc.getNumTechInfos(), 'TECH_PHILOSOPHY')
			for iPlayer in range(gc.getMAX_CIV_PLAYERS()):			
				loopPlayer = gc.getPlayer(iPlayer)
				if loopPlayer.isAlive():
					if gc.getTeam(loopPlayer.getTeam()).isHasTech(iTech):
						bFoundValid = true
						break

			if not bFoundValid:
				return True

## Golden Dawn Start ##

		return False

	def canCreate(self,argsList):
		pCity = argsList[0]
		eProject = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		return False

	def cannotCreate(self,argsList):
		pCity = argsList[0]
		eProject = argsList[1]
		bContinue = argsList[2]
		bTestVisible = argsList[3]
		return False

	def canMaintain(self,argsList):
		pCity = argsList[0]
		eProcess = argsList[1]
		bContinue = argsList[2]
		return False

	def cannotMaintain(self,argsList):
		pCity = argsList[0]
		eProcess = argsList[1]
		bContinue = argsList[2]
		return False

	def AI_chooseTech(self,argsList):
		ePlayer = argsList[0]
		bFree = argsList[1]
		return TechTypes.NO_TECH

	def AI_chooseProduction(self,argsList):
		pCity = argsList[0]

## Inquisitor Production AI ##

		iOwner = pCity.getOwner( )
		pPlayer = gc.getPlayer( pCity.getOwner( ) )
		iInquisitor = CvUtil.findInfoTypeNum( gc.getUnitInfo, gc.getNumUnitInfos(), "UNIT_INQUISITOR" )
		iStateReligion = gc.getPlayer( iOwner ).getStateReligion( )

		#Checks religion percents
		lReligions = [ ]
		bestReligionPercent = 0
		iStateLevel = 0
		for iReligionLoop in range(gc.getNumReligionInfos( )):
			if (gc.getGame().getReligionGameTurnFounded(iReligionLoop) > 0):
				iReligionLevel = gc.getGame().calculateReligionPercent(iReligionLoop)
				if iStateReligion >= 0:
					iStateLevel = gc.getGame().calculateReligionPercent(iStateReligion)
				if iReligionLevel > iStateLevel:
					lReligions.append( iReligionLoop )
				if (iReligionLoop != iStateReligion):
					religionPercent = gc.getGame().calculateReligionPercent(iReligionLoop)
					if (religionPercent > bestReligionPercent):
						bestReligionPercent = religionPercent

		if iStateReligion >= 0 or bestReligionPercent >= 60:
			if pCity.canTrain( iInquisitor, 0, 0 ):
				lUnits = PyPlayer( pPlayer.getID( ) ).getUnitList( )
				for iUnit in range( len( lUnits) ):
					# if there are any Inquisitors, don't Build one
					if pPlayer.getUnit( lUnits[ iUnit ].getID( ) ).getUnitType( ) == iInquisitor:
						return False
				if self.getRandomNumber( 2 ) == 0:
					gc.getMap( ).plot( pCity.getX( ), pCity.getY( ) ).getPlotCity( ).pushOrder( OrderTypes.ORDER_TRAIN, iInquisitor, -1, False, False, False, True )
					return True

## Inquisitor Productions AI ##

		return False

	def AI_unitUpdate(self,argsList):
		pUnit = argsList[0]
		iOwner = pUnit.getOwner( )
		iInquisitor = CvUtil.findInfoTypeNum( gc.getUnitInfo, gc.getNumUnitInfos(), "UNIT_INQUISITOR" )
		
		if not gc.getPlayer( iOwner ).isHuman( ):
			if pUnit.getUnitType( ) == iInquisitor:
				self.doInquisitorCore_AI( pUnit )
				return True
		return False

	def AI_doWar(self,argsList):
		eTeam = argsList[0]
		return False

	def AI_doDiplo(self,argsList):
		ePlayer = argsList[0]
		return False

	def calculateScore(self,argsList):
		ePlayer = argsList[0]
		bFinal = argsList[1]
		bVictory = argsList[2]
		
		iPopulationScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getPopScore(), gc.getGame().getInitPopulation(), gc.getGame().getMaxPopulation(), gc.getDefineINT("SCORE_POPULATION_FACTOR"), True, bFinal, bVictory)
		iLandScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getLandScore(), gc.getGame().getInitLand(), gc.getGame().getMaxLand(), gc.getDefineINT("SCORE_LAND_FACTOR"), True, bFinal, bVictory)
		iTechScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getTechScore(), gc.getGame().getInitTech(), gc.getGame().getMaxTech(), gc.getDefineINT("SCORE_TECH_FACTOR"), True, bFinal, bVictory)
		iWondersScore = CvUtil.getScoreComponent(gc.getPlayer(ePlayer).getWondersScore(), gc.getGame().getInitWonders(), gc.getGame().getMaxWonders(), gc.getDefineINT("SCORE_WONDER_FACTOR"), False, bFinal, bVictory)
		return int(iPopulationScore + iLandScore + iWondersScore + iTechScore)

	def doHolyCity(self):
		return False

	def doHolyCityTech(self,argsList):
		eTeam = argsList[0]
		ePlayer = argsList[1]
		eTech = argsList[2]
		bFirst = argsList[3]
		return False

	def doGold(self,argsList):
		ePlayer = argsList[0]
		return False

	def doResearch(self,argsList):
		ePlayer = argsList[0]
		return False

	def doGoody(self,argsList):
		ePlayer = argsList[0]
		pPlot = argsList[1]
		pUnit = argsList[2]
		return False

	def doGrowth(self,argsList):
		pCity = argsList[0]
		return False

	def doProduction(self,argsList):
		pCity = argsList[0]
		return False

	def doCulture(self,argsList):
		pCity = argsList[0]
		return False

	def doPlotCulture(self,argsList):
		pCity = argsList[0]
		bUpdate = argsList[1]
		ePlayer = argsList[2]
		iCultureRate = argsList[3]
		return False

	def doReligion(self,argsList):
		pCity = argsList[0]
		return False

	def cannotSpreadReligion(self,argsList):
		iOwner, iUnitID, iReligion, iX, iY = argsList[0]
		return False

	def doGreatPeople(self,argsList):
		pCity = argsList[0]
		return False

	def doMeltdown(self,argsList):
		pCity = argsList[0]
		return False
	
	def doReviveActivePlayer(self,argsList):
		"allows you to perform an action after an AIAutoPlay"
		iPlayer = argsList[0]
		return False
	
	def doPillageGold(self, argsList):
		"controls the gold result of pillaging"
		pPlot = argsList[0]
		pUnit = argsList[1]
		
		iPillageGold = 0
		iPillageGold = CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1")
		iPillageGold += CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2")

		iPillageGold += (pUnit.getPillageChange() * iPillageGold) / 100

## Himeji Samurai Castle and Suzerainty Start ##

		pPlayer = gc.getPlayer( pUnit.getOwner( ) )
		pPlayer2 = gc.getPlayer( pPlot.getOwner( ) )

		iLegalCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_LEGAL')
		iSuzerainty = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_JUDGE')
		iLegalCivic = pPlayer.getCivics(iLegalCivicOption)

		b_Himeji = gc.getInfoTypeForString("BUILDING_HIMEJI_CASTLE")
		obsoleteTech = gc.getBuildingInfo(b_Himeji).getObsoleteTech()

		if (iLegalCivic == iSuzerainty):

			if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
				for iCity in range(pPlayer.getNumCities()):
					ppCity = pPlayer.getCity(iCity)

					if ppCity.getNumActiveBuilding(b_Himeji) == true:
						iPillageGold = (( ( 0 ) * 5 ) / 2 )  
						iPillageGold = (( ( CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1") ) * 5 ) / 2 )  
						iPillageGold += (( ( CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2") ) * 5 ) / 2 ) 

						iPillageGold += ((((pUnit.getPillageChange() * iPillageGold) / 100 ) * 5 ) / 2 ) 

					else:
						iPillageGold = (((0)  * 3 ) / 2 )
						iPillageGold = (((CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1") *3 ) / 2 )) 
						iPillageGold += (((CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2") *3 ) / 2 )) 

						iPillageGold += ((((pUnit.getPillageChange() * iPillageGold) / 100) * 3 ) / 2 ) 


			if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == true or obsoleteTech == 1 ):
				iPillageGold = (((0)  * 3 ) / 2 )
				iPillageGold = (((CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1") *3 ) / 2 )) 
				iPillageGold += (((CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2") *3 ) / 2 )) 

				iPillageGold += ((((pUnit.getPillageChange() * iPillageGold) / 100) * 3 ) / 2 ) 

	
		if (iLegalCivic != iSuzerainty):

			if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
				for iCity in range(pPlayer.getNumCities()):
					ppCity = pPlayer.getCity(iCity)

					if ppCity.getNumActiveBuilding(b_Himeji) == true:
						iPillageGold = ( ( 0 ) * 2 ) 
						iPillageGold = ( ( CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1") ) * 2 )
						iPillageGold += ( ( CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2") ) * 2 )
	
						iPillageGold += ( ( (pUnit.getPillageChange() * iPillageGold) / 100 ) * 2 )

					else:
						iPillageGold = 0
						iPillageGold = CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1")
						iPillageGold += CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2")

						iPillageGold += (pUnit.getPillageChange() * iPillageGold) / 100

			if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == true or obsoleteTech == 1 ):
				iPillageGold = 0
				iPillageGold = CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 1")
				iPillageGold += CyGame().getSorenRandNum(gc.getImprovementInfo(pPlot.getImprovementType()).getPillageGold(), "Pillage Gold 2")

				iPillageGold += (pUnit.getPillageChange() * iPillageGold) / 100

## Himeji Samurai Castle and Suzerainty End ##
		
		return iPillageGold
	
	def doCityCaptureGold(self, argsList):
		"controls the gold result of capturing a city"
		
		pOldCity = argsList[0]

		iCaptureGold = 0
		
		iCaptureGold += gc.getDefineINT("BASE_CAPTURE_GOLD")
		iCaptureGold += (pOldCity.getPopulation() * gc.getDefineINT("CAPTURE_GOLD_PER_POPULATION"))
		iCaptureGold += CyGame().getSorenRandNum(gc.getDefineINT("CAPTURE_GOLD_RAND1"), "Capture Gold 1")
		iCaptureGold += CyGame().getSorenRandNum(gc.getDefineINT("CAPTURE_GOLD_RAND2"), "Capture Gold 2")

		if (gc.getDefineINT("CAPTURE_GOLD_MAX_TURNS") > 0):
			iCaptureGold *= cyIntRange((CyGame().getGameTurn() - pOldCity.getGameTurnAcquired()), 0, gc.getDefineINT("CAPTURE_GOLD_MAX_TURNS"))
			iCaptureGold /= gc.getDefineINT("CAPTURE_GOLD_MAX_TURNS")

## Himeji Samurai Castle Start ##

		pPlayer = gc.getPlayer( pOldCity.getOwner( ) )

		b_Himeji = gc.getInfoTypeForString("BUILDING_HIMEJI_CASTLE")
		obsoleteTech = gc.getBuildingInfo(b_Himeji).getObsoleteTech()

		if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
			for iCity in range(pPlayer.getNumCities()):
				ppCity = pPlayer.getCity(iCity)
				if ppCity.getNumActiveBuilding(b_Himeji) == true:
					iCaptureGold = 0
		
## Himeji Samurai Castle End ##

		return iCaptureGold
	
	def citiesDestroyFeatures(self,argsList):
		iX, iY= argsList
		return True
		
	def canFoundCitiesOnWater(self,argsList):
		iX, iY= argsList
		return False
		
	def doCombat(self,argsList):
		pSelectionGroup, pDestPlot = argsList
		return False

	def getConscriptUnitType(self, argsList):
		iPlayer = argsList[0]
		iConscriptUnitType = -1 #return this with the value of the UNIT TYPE you want to be conscripted, -1 uses default system
		
		return iConscriptUnitType

	def getCityFoundValue(self, argsList):
		iPlayer, iPlotX, iPlotY = argsList
		iFoundValue = -1 # Any value besides -1 will be used
		
		return iFoundValue
		
	def canPickPlot(self, argsList):
		pPlot = argsList[0]
		pGodsOfOld=CvEventInterface.getEventManager()
		if GodsOfOld.iPushButton == 2:
			if pPlot.isCoastalLand():
				return true
			else:
				return false
		if GodsOfOld.iPushButton == 3:
			if pPlot.isCity():
				iCoords = ( pPlot.getX(), pPlot.getY() )
				if pGodsOfOld.lPlagueCities.count( iCoords ) == 0:
					return true
				else:
					return false
			else:
				return false				
		return true
		
	def getUnitCostMod(self, argsList):
		iPlayer, iUnit = argsList
		iCostMod = -1 # Any value > 0 will be used

## Government Civic Unit Cost ## Disabled for the time being
#
#		iGovernmentCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_GOVERNMENT')
#		iHereditary = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_HEREDITARY_RULE')
#		iParliment = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_BIG')
#	
#		pUnitInfo = gc.getUnitInfo(iUnit)
#		
#		iSpy = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_SPY')
#		iCaravan = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CARAVAN')
#		iInquisitor = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_INQUISITOR')
#		iLawyer = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_LAWYER')
#		iEnvoy = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ENVOY')
#		iPythia = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EPONA')
#		iExecutive1 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_1')
#		iExecutive2 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_2')
#		iExecutive3 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_3')
#		iExecutive4 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_4')
#		iExecutive5 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_5')
#		iExecutive6 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_6')
#		iExecutive7 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_7')
#		iExecutive8 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_EXECUTIVE_8')
#		iMissionary1 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_JEWISH_MISSIONARY')
#		iMissionary2 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CHRISTIAN_MISSIONARY')
#		iMissionary3 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_HINDU_MISSIONARY')
#		iMissionary4 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_BUDDHIST_MISSIONARY')
#		iMissionary5 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_CONFUCIAN_MISSIONARY')
#		iMissionary6 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TAOIST_MISSIONARY')
#		iMissionary7 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_PAGAN_MISSIONARY')
#		iMissionary8 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ISLAMIC_MISSIONARY')
#		iMissionary9 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ZORO_MISSIONARY')
#		iMissionary10 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_SHINTO_MISSIONARY')
#		iMissionary11 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_ASEN_MISSIONARY')
#		iMissionary12 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_RA_MISSIONARY')
#		iMissionary13 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TOLTEC_MISSIONARY')
#		iMissionary14 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_VOODOO_MISSIONARY')
#		iMissionary15 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_TENGRI_MISSIONARY')
#		iMissionary16 = CvUtil.findInfoTypeNum(gc.getUnitInfo,gc.getNumUnitInfos(),'UNIT_LEVANT_MISSIONARY')
#		
#		aiSpyHereditaryList = [iSpy]
#		aiDiplomatList = [iCaravan, iInquisitor, iLawyer, iEnvoy, iPythia, iExecutive1, iExecutive2, iExecutive3, iExecutive4, iExecutive5, iExecutive6, iExecutive7, iExecutive8, iMissionary1, iMissionary2, iMissionary3, iMissionary4, iMissionary5, iMissionary6, iMissionary7, iMissionary8, iMissionary9, iMissionary10, iMissionary11, iMissionary12, iMissionary13, iMissionary14, iMissionary15, iMissionary16]
#		
#		pPlayer = gc.getPlayer(iPlayer)
#		
#		iGovernmentCivic = pPlayer.getCivics(iGovernmentCivicOption)
#		
#		if (iGovernmentCivic == iHereditary):
#			if (iUnit in aiSpyHereditaryList):
#				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(gc.getInfoTypeForString("TECH_DRAMA")) == true ):
#					return 80	# 80% of normal cost
#		elif (iGovernmentCivic == iParliment):
#			if (iUnit in aiDiplomatList):
#				return 80	# 80% of normal cost
#		
#		return -1
#
## Government Civic Unit Cost ## Disabled for the time being

		return iCostMod

	def getBuildingCostMod(self, argsList):
		iPlayer, iCityID, iBuilding = argsList
		pPlayer = gc.getPlayer(iPlayer)
		pCity = pPlayer.getCity(iCityID)
		
		iCostMod = -1 # Any value > 0 will be used

## Social Civic Building Cost ##

		iSocialCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_LEGAL')
		iUrban = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_JUDGE')
	
		pBuildingInfo = gc.getBuildingInfo(iBuilding)
		
		iStonehenge = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_STONEHENGE')
		iAdam = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_LEONARDOS_WORKSHOP')
		iWat = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ANGKOR_WAT')
		iArc = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ARC')
		i51 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_51')
		iBen = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_BEN')
		iBroadway = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_BROADWAY')
		iCDC = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_CENTERS_FOR_DISEASE_CONTROL')
		iItza = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_CHICHEN_ITZA')
		iCristo = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_CRISTO_REDENTOR')
		iMan = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SPACE_ELEVATOR2')
		iFallout = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_FALLOUT_SHELTER')
		iFlavian = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_FLAV')
		iPalace = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PALACE')
		iGreatPalace = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GREAT_PALACE')
		iVersailles = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_VERSAILLES')
		iForce = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ADVANCED_SHIELDING3')
		iGlobe = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GLOBE_THEATRE')
		iGraceland = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ROCKNROLL')
		iJoseph = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_JOSEPH')
		iHermitage = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HERMITAGE')
		iHero = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HEROIC_EPIC')
		iHollywood = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HOLLYWOOD')
		iIron = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_IRON_WORKS')
		iKGB = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_KGB')
		iMachu = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_MACHU_PICCHU')
		iMausoleum = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_MAUSOLEUM_OF_MAUSSOLLOS')
		iMoai = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_MOAI_STATUES')
		iRushmore = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_MT_RUSHMORE')
		iNASA = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_NASA')
		iNational = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_NATIONAL_EPIC')
		iPark = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_NATIONAL_PARK')
		iNotre = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_NOTRE_DAME')
		iOxford = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_OXFORD_UNIVERSITY')
		iPetra = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PETRA')
		iTomb = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ROYALT')
		iPaya = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SHWEDAGON_PAYA')
		iArtofWar = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SWAR')
		iTemplo = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TEMPLO_MAYOR')
		iPope = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_APOSTOLIC_PALACE')
		iKos = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ASCL')
		iColossus = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_COLOSSUS')
		iDNA = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_DNA')
		iEiffel = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_EIFFEL_TOWER')
		iLibrary = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GREAT_LIBRARY')
		iLighthouse = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GREAT_LIGHTHOUSE')
		iWall = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GREAT_WALL')
		iHagia = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HAGIA_SOPHIA')
		iGarden = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HANGING_GARDEN')
		iIshtar = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PAGAN_SHRINE2')
		iKremlin = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_KREMLIN')
		iOracle = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ORACLE')
		iParthenon = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PARTHENON')
		iPentagon = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PENTAGON')
		iPyramids = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PYRAMID')
		iConfucius = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PALACE_CHINA')
		iSilk = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SILK')
		iSistine = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SISTINE_CHAPEL')
		iSpace = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SPACE_ELEVATOR')
		iMinaret = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SPIRAL_MINARET')
		iLiberty = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_STATUE_OF_LIBERTY')
		iZeus = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_STATUE_OF_ZEUS')
		iTaj = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TAJ_MAHAL')
		iArtemis = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ARTEMIS')
		iGorges = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GREAT_DAM')
		iUN = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_LEAGUE_OF_NATIONS')
		iSankore = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SANKORE')
		iVia = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_VIA_APPIA')
		iWallStreet = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_WALL_STREET')
		iWestPoint = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_WEST_POINT')
		ieBank = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_E_BANK')
		iSilo = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SILO')
		iSquare = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TRAFALGAR_SQUARE')
		iFish = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_MOAI_STATUES2')
		iFusion = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_FUSIONSREAKTOR')
		iTesla = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TESLA')
		iDjenne = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_DJENNE')
		iIceHotel = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ICE_HOTEL')
		iPublicWorks = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PUBLIC_WORKS')
		iBridge = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_BRIDGE')
		iLeonardo = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_LEONARDO')
		iBath = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_GREAT_BATH')
		iHimeji = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HIMEJI_CASTLE')
		iSydney = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SYDNEY_OPERA_HOUSE')
		iHDawn = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_COPERNICUS')

		iCathedral1 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_JEWISH_CATHEDRAL')
		iCathedral2 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_CHRISTIAN_CATHEDRAL')
		iCathedral3 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ISLAMIC_CATHEDRAL')
		iCathedral4 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_HINDU_CATHEDRAL')
		iCathedral5 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_BUDDHIST_CATHEDRAL')
		iCathedral6 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_CONFUCIAN_CATHEDRAL')
		iCathedral7 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TAOIST_CATHEDRAL')
		iCathedral8 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_PAGAN_CATHEDRAL')
		iCathedral9 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ZORO_CATHEDRAL')
		iCathedral10 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_SHINTO_CATHEDRAL')
		iCathedral11 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_ASEN_CATHEDRAL')
		iCathedral12 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_RA_CATHEDRAL')
		iCathedral13 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TOLTEC_CATHEDRAL')
		iCathedral14 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_VOODOO_CATHEDRAL')
		iCathedral15 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_TENGRI_CATHEDRAL')
		iCathedral16 = CvUtil.findInfoTypeNum(gc.getBuildingInfo,gc.getNumBuildingInfos(),'BUILDING_LEVANT_CATHEDRAL')
		
		aiWonderList = [iStonehenge, iAdam, iWat, iArc, i51, iBen, iBroadway, iCDC, iItza, iCristo, iMan, iFallout, iFlavian, iPalace, iGreatPalace, iVersailles, iForce, iGlobe, iGraceland, iJoseph, iHermitage, iHero, iHollywood, iIron, iKGB, iMachu, iMausoleum, iMoai, iRushmore, iNASA, iNational, iPark, iNotre, iOxford, iPetra, iTomb, iPaya, iArtofWar, iTemplo, iPope, iKos, iColossus, iDNA, iEiffel, iLibrary, iLighthouse, iWall, iHagia, iGarden, iIshtar, iKremlin, iOracle, iParthenon, iPentagon, iPyramids, iConfucius, iSilk, iSistine, iSpace, iMinaret, iLiberty, iZeus, iTaj, iArtemis, iGorges, iUN, iSankore, iVia, iWallStreet, iWestPoint, ieBank, iSilo, iSquare, iFish, iFusion, iTesla, iDjenne, iIceHotel, iPublicWorks, iBridge, iLeonardo, iBath, iHimeji, iSydney, iHDawn]
		aiCathedralList = [iCathedral1, iCathedral2, iCathedral3, iCathedral4, iCathedral5, iCathedral6, iCathedral7, iCathedral8, iCathedral9, iCathedral10, iCathedral11, iCathedral12, iCathedral13, iCathedral14, iCathedral15, iCathedral16]

		pPlayer = gc.getPlayer(iPlayer)
		pPlayer1 = gc.getPlayer(pCity.plot().getOwner())

		bSphinx = gc.getInfoTypeForString("BUILDING_SPHINX")
		obsoleteTech = gc.getBuildingInfo(bSphinx).getObsoleteTech()
		if ( gc.getTeam(pPlayer1.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
			for iCity in range(pPlayer1.getNumCities()):
				ppCity = pPlayer1.getCity(iCity)
				if ppCity.getNumActiveBuilding(bSphinx) == true:
					if (iBuilding in aiWonderList):
						return 80	# 80% of normal cost

		bDjenne = gc.getInfoTypeForString("BUILDING_DJENNE")
		obsoleteTech = gc.getBuildingInfo(bDjenne).getObsoleteTech()
		if ( gc.getTeam(pPlayer1.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
			for iCity in range(pPlayer1.getNumCities()):
				ppCity = pPlayer1.getCity(iCity)
				if ppCity.getNumActiveBuilding(bDjenne) == true:
					if (iBuilding in aiCathedralList):
						return 50	# 50% of normal cost

		iSocialCivic = pPlayer.getCivics(iSocialCivicOption)
		
		return -1

## Social Civic Building Cost ##
		
		return iCostMod
		
	def canUpgradeAnywhere(self, argsList):
		pUnit = argsList
		
		bCanUpgradeAnywhere = 0
		
		return bCanUpgradeAnywhere
		
	def getWidgetHelp(self, argsList):
		eWidgetType, iData1, iData2, bOption = argsList
		if iData1 == 666:
			return CyTranslator().getText("TXT_KEY_GODS_EARTHQUAKE_MOUSE_OVER_CHANGED", ())
		if iData1 == 667:
			return CyTranslator().getText("TXT_KEY_GODS_TSUNAMI_MOUSE_OVER_CHANGED", ())
		if iData1 == 668:
			return CyTranslator().getText("TXT_KEY_GODS_PLAGUE_MOUSE_OVER_CHANGED", ())
		if iData1 == 669:
			return CyTranslator().getText("TXT_KEY_GODS_METEOR_MOUSE_OVER_CHANGED", ())
		if iData1 == 670:
			return CyTranslator().getText("TXT_KEY_GODS_BLIGHT_MOUSE_OVER_CHANGED", ())
		if iData1 == 665:
			return CyTranslator().getText("TXT_KEY_GODS_INQUISTOR_CLEANSE_MOUSE_OVER", ())		
		return u""
		
	def getUpgradePriceOverride(self, argsList):
		iPlayer, iUnitID, iUnitTypeUpgrade = argsList

## Str and Leonardo and Parlimentary Start ##

		pPlayer = gc.getPlayer(iPlayer)
		iTrait = CvUtil.findInfoTypeNum(gc.getTraitInfo,gc.getNumTraitInfos(),'TRAIT_STRATEGIC')
		b_Leonardo = gc.getInfoTypeForString("BUILDING_LEONARDO")
		obsoleteTech = gc.getBuildingInfo(b_Leonardo).getObsoleteTech()
		pUnit = pPlayer.getUnit(iUnitID)

		iGovermentCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_GOVERNMENT')
		iParliment = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_BIG')
		iGovernmentCivic = pPlayer.getCivics(iGovermentCivicOption)

		iPrice = gc.getDefineINT("BASE_UNIT_UPGRADE_COST")
		iPrice += (max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION"))

		if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
			pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
			iPrice = iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100
			iPrice = iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100

		iPrice = iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100)


		if (iGovernmentCivic == iParliment):

			if (pPlayer.hasTrait(iTrait)):

				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
					for iCity in range(pPlayer.getNumCities()):
						ppCity = pPlayer.getCity(iCity)
						if ppCity.getNumActiveBuilding(b_Leonardo) == true:

							iPrice = ((((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/4)*3)/4)
							iPrice += (((((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/4)*3)/4)

							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = ((((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/4)*3)/4)
								iPrice = ((((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/4)*3)/4)

								iPrice = ((((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/4)*3)/4)

						if ppCity.getNumActiveBuilding(b_Leonardo) == false:

							iPrice = ((((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/2)*3)/4)
							iPrice += (((((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/2)*3)/4)

							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = ((((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/2)*3)/4)
								iPrice = ((((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/2)*3)/4)

								iPrice = ((((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/2)*3)/4)


				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == true or obsoleteTech == 1 ):

					iPrice = ((((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/2)*3)/4)
					iPrice += (((((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/2)*3)/4)

					if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
						pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
						iPrice = ((((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/2)*3)/4)
						iPrice = ((((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/2)*3)/4)

						iPrice = ((((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/2)*3)/4)



			else:

				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
					for iCity in range(pPlayer.getNumCities()):
						ppCity = pPlayer.getCity(iCity)

						if ppCity.getNumActiveBuilding(b_Leonardo) == true:

							iPrice = ((((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/2)*3)/4)
							iPrice += (((((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/2)*3)/4)
	
							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = ((((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/2)*3)/4)
								iPrice = ((((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/2)*3)/4)
	
								iPrice = ((((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/2)*3)/4)


						if ppCity.getNumActiveBuilding(b_Leonardo) == false:

							iPrice = (((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))*3)/4)
							iPrice += ((((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))*3)/4)

							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = (((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)*3)/4)
								iPrice = (((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)*3)/4)

								iPrice = (((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))*3)/4)


				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == true or obsoleteTech == 1 ):

					iPrice = (((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))*3)/4)
					iPrice += ((((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))*3)/4)

					if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
						pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
						iPrice = (((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)*3)/4)
						iPrice = (((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)*3)/4)

						iPrice = (((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))*3)/4)

		if (iGovernmentCivic != iParliment):

			if (pPlayer.hasTrait(iTrait)):

				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
					for iCity in range(pPlayer.getNumCities()):
						ppCity = pPlayer.getCity(iCity)
						if ppCity.getNumActiveBuilding(b_Leonardo) == true:

							iPrice = ((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/4)
							iPrice += (((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/4)

							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = ((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/4)
								iPrice = ((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/4)

								iPrice = ((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/4)

						if ppCity.getNumActiveBuilding(b_Leonardo) == false:

							iPrice = ((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/2)
							iPrice += (((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/2)

							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = ((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/2)
								iPrice = ((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/2)

								iPrice = ((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/2)


				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == true or obsoleteTech == 1 ):

					iPrice = ((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/2)
					iPrice += (((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/2)

					if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
						pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
						iPrice = ((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/2)
						iPrice = ((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/2)

						iPrice = ((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/2)

			else:

				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == false or obsoleteTech == -1 ):
					for iCity in range(pPlayer.getNumCities()):
						ppCity = pPlayer.getCity(iCity)

						if ppCity.getNumActiveBuilding(b_Leonardo) == true:

							iPrice = ((gc.getDefineINT("BASE_UNIT_UPGRADE_COST"))/2)
							iPrice += (((max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")))/2)
	
							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = ((iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100)/2)
								iPrice = ((iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100)/2)
	
								iPrice = ((iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100))/2)


						if ppCity.getNumActiveBuilding(b_Leonardo) == false:


							iPrice = gc.getDefineINT("BASE_UNIT_UPGRADE_COST")
							iPrice += (max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION"))

							if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
								pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
								iPrice = iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100
								iPrice = iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100

								iPrice = iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100)


				if ( gc.getTeam(pPlayer.getTeam()).isHasTech(obsoleteTech) == true or obsoleteTech == 1 ):

					iPrice = gc.getDefineINT("BASE_UNIT_UPGRADE_COST")
					iPrice += (max(0, (pPlayer.getUnitProductionNeeded(iUnitTypeUpgrade) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType()))) * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION"))

					if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
						pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
						iPrice = iPrice * pHandicapInfo.getAIUnitUpgradePercent() / 100
						iPrice = iPrice * max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100)) / 100

					iPrice = iPrice - ((iPrice * pUnit.getUpgradeDiscount()) / 100)

		return iPrice

## Str and Leonardo and Parlimentary End ##
		
		return -1	# Any value 0 or above will be used

	def getRandomNumber(self, int):
		return CyGame().getSorenRandNum(int, "Gods_CvGameUtils")
				
	def doInquisitorCore_AI( self, pUnit ):
		iOwner = pUnit.getOwner( )
		pOwner = gc.getPlayer( iOwner )
		iTurn = PyGame( ).getGameTurn()
		iOwnCulture = gc.getPlayer( iOwner ).getCultureHistory( iTurn )
		iStateReligion = gc.getPlayer( iOwner ).getStateReligion( )
		lCities = PyPlayer( iOwner ).getCityList( )
		lPlayers = PyGame( ).getCivPlayerList( )

		#Checks religion percents
		lReligions = [ ]
		bestReligionPercent = 0
		iBestReligion = -1
		for iReligionLoop in range(gc.getNumReligionInfos( )):
			iReligionLevel = gc.getGame().calculateReligionPercent(iReligionLoop)
			if iStateReligion == -1 or iReligionLevel > gc.getGame().calculateReligionPercent(iStateReligion):
				lReligions.append( iReligionLoop )
			if (iReligionLoop != iStateReligion):
				religionPercent = gc.getGame().calculateReligionPercent(iReligionLoop)
				if (religionPercent > bestReligionPercent):
					bestReligionPercent = religionPercent
					iBestReligion = iReligionLoop

		#Prevent religious victory
		if bestReligionPercent >= 60:
			for iCity in range( len( lCities ) ):
				pCity = gc.getPlayer( iOwner ).getCity( lCities[ iCity ].getID( ) )
				if pCity.isHasReligion( iBestReligion ):
					#Makes the unit move to the City and purge it
					if pUnit.generatePath( pCity.plot( ), 0, False, None ):
						self.doHolyCitySeekAndDestroy( pUnit, pCity )
						return

		# Should AI use inquisitor
		if iStateReligion >= 0:

			#Looks to see if the AI controls a Holy City
			for iCity in range( len( lCities ) ):
				pCity = gc.getPlayer( iOwner ).getCity( lCities[ iCity ].getID( ) )
				for iReligion in range( gc.getNumReligionInfos( ) ):
					if iReligion == iStateReligion:
						if pCity.isHolyCityByType( iReligion ) or pOwner.isCivic(CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_THEOCRACY')):

							#Checks culture levels
							lPlayerCultures = [ ]
							for iPlayerLoop in range( len( lPlayers ) ):
								iPlayer = lPlayers[ iPlayerLoop ].getID()
								iCulture = gc.getPlayer(iPlayer).getCultureHistory( iTurn )
								if iCulture >= iOwnCulture:
									lPlayerCultures.append( iPlayerLoop )
				
							if ( ( len( lPlayerCultures ) ) / ( len( lPlayers ) ) * 100 >= 33 ) and ( ( len( lReligions ) ) / ( gc.getNumReligionInfos( ) ) * 100 ) >= 33:

		
								#Looks to see if the AI controls a Holy City that is not the State Religion
								for iCity in range( len( lCities ) ):
									pCity = gc.getPlayer( iOwner ).getCity( lCities[ iCity ].getID( ) )
									if pCity.isHasReligion( iStateReligion ):
										for iReligion in range( gc.getNumReligionInfos( ) ):
											if iReligion != iStateReligion:
												if pCity.isHolyCityByType( iReligion ):
													#Makes the unit move to the City and purge it
													if pUnit.generatePath( pCity.plot( ), 0, False, None ):
														self.doHolyCitySeekAndDestroy( pUnit, pCity )
														return
		
								for iCity in range( len( lCities ) ):
									pCity = gc.getPlayer( iOwner ).getCity( lCities[ iCity ].getID( ) )
									if pCity.isHasReligion( iStateReligion ):
										for iReligion in range(gc.getNumReligionInfos( )):
											if iReligion != iStateReligion:
												if pCity.isHasReligion( iReligion ):
													if pUnit.generatePath( pCity.plot( ), 0, False, None ):
														self.doHolyCitySeekAndDestroy( pUnit, pCity )
														return						
								
	
	def doHolyCitySeekAndDestroy( self, pUnit, pCity ):
		Gods = CvEventInterface.getEventManager( )
		
		if pUnit.getX( ) != pCity.getX( ) or pUnit.getY( ) != pCity.getY( ):
			pUnit.getGroup().pushMission(MissionTypes.MISSION_MOVE_TO, pCity.getX( ), pCity.getY( ), 0, False, True, MissionAITypes.NO_MISSIONAI, pUnit.plot(), pUnit)
		else:
			Gods.doInquisitorPersecution( pCity, pUnit )	
	
	def getExperienceNeeded(self, argsList):
		# use this function to set how much experience a unit needs
		iLevel, iOwner = argsList
		
		iExperienceNeeded = 0

		# regular epic game experience		
		iExperienceNeeded = iLevel * iLevel + 1

		iModifier = gc.getPlayer(iOwner).getLevelExperienceModifier()
		if (0 != iModifier):
			iExperienceNeeded += (iExperienceNeeded * iModifier + 99) / 100   # ROUND UP

## Hereditary Vassal Bonus Start ##
#
#		pPlayer = gc.getPlayer(iOwner)
#		iTeam = pPlayer.getTeam()
#		pTeam = gc.getTeam(iTeam)
#		lPlayers = PyGame().getCivPlayerList( )
#
#		iGovernmentCivicOption = CvUtil.findInfoTypeNum(gc.getCivicOptionInfo,gc.getNumCivicOptionInfos(),'CIVICOPTION_GOVERNMENT')
#		iHereditary = CvUtil.findInfoTypeNum(gc.getCivicInfo,gc.getNumCivicInfos(),'CIVIC_HEREDITARY_RULE')
#		iGovernmentCivic = pPlayer.getCivics(iGovernmentCivicOption)
#
#		if (iGovernmentCivic == iHereditary):
#
#			for iPlayer in range(gc.getMAX_PLAYERS()):
#				ppPlayer = gc.getPlayer(iPlayer)
#				if ( (ppPlayer.isAlive()==true) and (ppPlayer.isBarbarian()==false) ):
#					if ( gc.getTeam(ppPlayer.getTeam()).isVassal(iTeam) == true ):
#
#						iExperienceNeeded = (((0 ) * 9 ) / 10 )
#
#						# regular epic game experience		
#						iExperienceNeeded = (((iLevel * iLevel + 1) * 9 ) / 10 )
#
#						iModifier = gc.getPlayer(iOwner).getLevelExperienceModifier()
#						if (0 != iModifier):
#							iExperienceNeeded += ((((iExperienceNeeded * iModifier + 99) / 100) * 9 ) / 10 )# ROUND UP
#
## Hereditary Vassal Bonus End ##
			
		return iExperienceNeeded
		